import matplotlib.pyplot as plt
import scipy
import numpy as np
import pylab

inv_im = lambda eps1, eps2: - eps2/( eps1**2 + eps2**2  ) 
       
freq_1_ev, re_inv_eps, im_inv_eps, re_eps, im_eps  = np.loadtxt( "Al_2p7gcc_0p3ev_4el_q_1p27AA_Lanczos_RPA.OUT", skiprows = 0 , usecols=(0,1,2,3,4), unpack=True ) 
 
plt.plot( freq_1_ev, inv_im(re_eps, -im_eps), 'b-.', markerfacecolor='none' )   
#plt.show()    

def FWHM(X,Y):
    half_max = max(Y) / 2.
    #find when function crosses line half_max (when sign of diff flips)
    #take the 'derivative' of signum(half_max - Y[])
    d = sign(half_max - array(Y[0:-1])) - sign(half_max - array(Y[1:]))
    #plot(X[0:len(d)],d) #if you are interested
    #find the left and right most indexes
    left_idx = find(d > 0)[0]
    right_idx = find(d < 0)[-1]
    return X[right_idx] - X[left_idx] #return the difference (full width)  


#FWHM( freq_11_ev, inv_im(eps_11, -eps_12)  ) 

max_y = np.max( im_inv_eps  ) 

xs = [x for x in range( len(freq_1_ev) ) if im_inv_eps[x] > max_y/2.0]

#print min(xs), max(xs) # Print the points at half-maximum 
#print freq_11_ev[ min(xs) ] ,  freq_11_ev[ max(xs) ]  

print("plasmon width in eV : ",  freq_1_ev[ max(xs) ] - freq_1_ev[ min(xs) ]  )

plt.show() 
